{ ***************************************************************** }
{ *								                                                * }
{ *    				                          * }
{ *								                                                * }
{ *  :	11  2005 			                    * }
{ * :          	 	                                      * }
{ * E-Mail:         pavel2012@narod.ru			                      * }
{ * Site:           http://pavel2012.narod.ru/                    * }
{ *								                                                * }
{ ***************************************************************** }

{$WARNINGS OFF}

unit LeakMemory;

interface

implementation

uses Windows;

var
  OldMemoryManager: TMemoryManager;
  AllocationCount: Int64;

//   ,
//      GetMem.

function CheckGetMem(Size: Integer): Pointer;
begin
  //    GetMem   
  Result := OldMemoryManager.GetMem(Size);
  //    GetMem
  Inc(AllocationCount);
end;

//   ,
//      FreeMem.

function CheckFreeMem(Address: Pointer): Integer;
begin
  //    FreeMem   
  Result := OldMemoryManager.FreeMem(Address);
  //    GetMem
  Dec(AllocationCount);
end;

//   

procedure Startup;
var
  MemoryManager: TMemoryManager;
begin
  //    
  GetMemoryManager(OldMemoryManager);
  with MemoryManager do
    begin
      //    GetMem
      GetMem := @CheckGetMem;
      //    FreeMem
      FreeMem := @CheckFreeMem;
      // ReallocMem     ,
      // ..     GetMem  FreeMem
      ReallocMem := OldMemoryManager.ReallocMem;
    end;
  //    GetMem
  AllocationCount := 0;
  //    
  SetMemoryManager(MemoryManager);
end;

//       

procedure Shutdown;
resourcestring
  sLeakMemoryCaption = ' ';
  sFreeMemoryError = '     ,'#13#10'    .';
  sNeedFreeMemoryError = '        .';
begin
  //    
  SetMemoryManager(OldMemoryManager);
  //   FreeMem  ,  GetMem,  ...
  if AllocationCount > 0 then
    //    
    MessageBox(0, PChar(sNeedFreeMemoryError), PChar(sLeakMemoryCaption), MB_OK or MB_ICONWARNING)
  else
    //    FreeMem  ,  GetMem,  ...
    if AllocationCount < 0 then
      //    
      MessageBox(0, PChar(sFreeMemoryError), PChar(sLeakMemoryCaption), MB_OK or MB_ICONWARNING);
end;

initialization
  //  
  Startup;

finalization
  //  
  Shutdown;

end.

